package com.muyu.etl.common.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.muyu.common.core.web.domain.BaseEntity;
import com.muyu.etl.common.domain.req.EtlRuleAddReq;
import com.muyu.etl.common.domain.req.EtlRuleUpdReq;
import lombok.*;
import lombok.experimental.SuperBuilder;

import java.util.function.Supplier;

/**
 * @Author：张承志
 * @Package：com.muyu.damain
 * @Project：cloud-etl
 * @name：Rule
 * @Date：2024/8/21 11:33
 */

@Data
@SuperBuilder
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@TableName(value = "etl_rule",autoResultMap = true)
public class EtlRule extends BaseEntity {

    /**
     *主键
     */
    @TableId(value = "id" , type = IdType.AUTO)
    private Long id ;
    /** 规则名称 */

    private String name ;
    /** 规则类型 */

    private String type ;
    /** 全限定类名 */

    private String fullClassName ;

    /** 规则说明 */
    private String explain ;

    /** 是否公开 0已激活 1未激活 */
    private String open ;


    /** 状态 0正常 1停用 */
    private String status ;


    public static EtlRule updBuild(EtlRuleUpdReq etlRule, Supplier<Long> longSupplier){

      return EtlRule.builder().id(longSupplier.get())
                 .open(etlRule.getOpen())
                 .name(etlRule.getName())
                 .status(etlRule.getStatus())
                 .type(etlRule.getType())
                 .explain(etlRule.getExplain())
                 .remark(etlRule.getRemark())
                 .build();

    }

    public static EtlRule addBuild(EtlRuleAddReq etlRule){

        return EtlRule.builder()
                .open(etlRule.getOpen())
                .name(etlRule.getName())
                .status(etlRule.getStatus())
                .type(etlRule.getType())
                .explain(etlRule.getExplain())
                .remark(etlRule.getRemark())
                .build();

    }
}
